/*******************************************************************************
*   touch.c
*   Atmel Corporation:  http://www.atmel.com \n
*   xEҰ:  touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/
/* ͎Iɐꂽ̧قłBe蓮ŕύXȂłB
   ɁA݌vɕύXsɂProject BuilderްނgpĂB
*/
/*----------------------------------------------------------------------------
								  ߲׏
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								 ݸٰ ̧
----------------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>

#define __enable_interrupt()	sei()
#define __delay_cycles(n)		__builtin_avr_delay_cycles(n)

/* ŏŒ`ꂽǏŐڐGapi.hݸٰ */
#include "touch_api.h"
#include "touch.h"

#ifdef _DEBUG_INTERFACE_
/* QTouch Studiop̧قݸٰ
  #include "QDebug.h"
  #include "QDebugTransport.h"
#endif

/*----------------------------------------------------------------------------
								 炩Ȓ萔
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									^`
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ^
----------------------------------------------------------------------------*/

static void qt_set_parameters (void);	/* Sʌ`ԐݒҰ\̂Ұl蓖 */
static void config_sensors (void);		/* m`Ԑݒ */
#ifdef _DEBUG_INTERFACE_
#ifdef _QDEBUG_TIME_STAMPS_
void set_timestamp1(void);				// ԈɎgp
#endif
#endif

/*----------------------------------------------------------------------------
								   \̐錾
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									  ϸ
----------------------------------------------------------------------------*/

#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
/* ̺̉ނ͏Ɋ֘A鎞ԈɎgp܂B */
  #define TIMESTAMP0	asm("cli"); timestamp0_lword = (uint16_t)TIMER_COUNTER_L;timestamp0_lword |= (uint16_t)(TIMER_COUNTER_H << 8); timestamp0_hword = current_time_ms_touch; asm("sei");
  #define TIMESTAMP1	asm("cli"); timestamp1_lword = (uint16_t)TIMER_COUNTER_L;timestamp1_lword |= (uint16_t)(TIMER_COUNTER_H << 8); timestamp1_hword = current_time_ms_touch; asm("sei");
  #define TIMESTAMP2	asm("cli"); timestamp2_lword = (uint16_t)TIMER_COUNTER_L;timestamp2_lword |= (uint16_t)(TIMER_COUNTER_H << 8); timestamp2_hword = current_time_ms_touch; asm("sei");
  #define TIMESTAMP3	asm("cli"); timestamp3_lword = (uint16_t)TIMER_COUNTER_L;timestamp3_lword |= (uint16_t)(TIMER_COUNTER_H << 8); timestamp3_hword = current_time_ms_touch; asm("sei");
  #define TIMESTAMP4	asm("cli"); timestamp4_lword = (uint16_t)TIMER_COUNTER_L;timestamp4_lword |= (uint16_t)(TIMER_COUNTER_H << 8); timestamp4_hword = current_time_ms_touch; asm("sei");
  #endif
#else
  #define TIMESTAMP0	{}
  #define TIMESTAMP1	{}
  #define TIMESTAMP2	{}
  #define TIMESTAMP3	{}
  #define TIMESTAMP4	{}
#endif
/*----------------------------------------------------------------------------
								   Sϐ
----------------------------------------------------------------------------*/

#ifdef _DEBUG_INTERFACE_
 #ifdef _QDEBUG_TIME_STAMPS_
  uint16_t timestamp0_hword=0;
  uint16_t timestamp0_lword=0;
  uint16_t timestamp1_hword=0;
  uint16_t timestamp1_lword=0;
  uint16_t timestamp2_hword=0;
  uint16_t timestamp2_lword=0;
  uint16_t timestamp3_hword=0;
  uint16_t timestamp3_lword=0;
  uint16_t timestamp4_hword=0;
  uint16_t timestamp4_lword=0;
 #endif
#endif

/*----------------------------------------------------------------------------
								   Oϐ
----------------------------------------------------------------------------*/
/* ύXKvȏꍇɂ̌`Ԑݒް\Ұqt_set_parameters֐ŕύX
   ܂B */
extern qt_touch_lib_config_data_t qt_config_data;
extern qt_touch_lib_measure_data_t qt_measure_data;					/* ް */
qt_touch_lib_measure_data_t *pqt_measure_data = &qt_measure_data;
extern int16_t qt_get_sensor_delta( uint8_t sensor);				/* m퍷l擾 */

#ifdef _QMATRIX_
  extern y_line_info_t y_line_info[NUM_Y_LINES];
  extern x_line_info_t x_line_info[NUM_X_LINES];

/* IꂽXY߰ĂłXY̎Օl
* X̔ԍt̏Ԃ͂̕@ɏ]܂B
*
*/

x_line_info_t x_line_info[NUM_X_LINES]= {
FILL_OUT_X_LINE_INFO(1,0),
FILL_OUT_X_LINE_INFO(1,1),
FILL_OUT_X_LINE_INFO(1,2),
FILL_OUT_X_LINE_INFO(1,3),
FILL_OUT_X_LINE_INFO(1,4),
FILL_OUT_X_LINE_INFO(1,5),
FILL_OUT_X_LINE_INFO(1,6),
FILL_OUT_X_LINE_INFO(1,7)};

y_line_info_t ya_line_info[NUM_Y_LINES]={
FILL_OUT_YA_LINE_INFO(0),
FILL_OUT_YA_LINE_INFO(1),
FILL_OUT_YA_LINE_INFO(2),
FILL_OUT_YA_LINE_INFO(3),
FILL_OUT_YA_LINE_INFO(4),
FILL_OUT_YA_LINE_INFO(5),
FILL_OUT_YA_LINE_INFO(6),
FILL_OUT_YA_LINE_INFO(7),
};

y_line_info_t yb_line_info[NUM_Y_LINES]={
FILL_OUT_YB_LINE_INFO(0),
FILL_OUT_YB_LINE_INFO(1),
FILL_OUT_YB_LINE_INFO(2),
FILL_OUT_YB_LINE_INFO(3),
FILL_OUT_YB_LINE_INFO(4),
FILL_OUT_YB_LINE_INFO(5),
FILL_OUT_YB_LINE_INFO(6),
FILL_OUT_YB_LINE_INFO(7),
};

#endif/*_QMATRIX_*/

extern uint8_t time_to_measure_touch;
extern uint16_t current_time_ms_touch;

/*----------------------------------------------------------------------------
								   ÓIϐ
----------------------------------------------------------------------------*/

/*============================================================================
O: touch_init
------------------------------------------------------------------------------
ړI: ͐ڐG֘Aނ܂B
: Ȃ
o: Ȃ
:
============================================================================*/
void touch_init (void)
{
    config_sensors();		/* ̊֐Ŋm𷰂܂͉]q/q·ƂČ`Ԑݒ */
    qt_init_sensing();		/* ڐGm */
    qt_set_parameters( );	/* gp҂ɂĂ̊֐ōčZ臒lAőONԂȂǂ̂悤Ұݒ */

	/* gpҊ֐̱ڽn߂̱ڽ */
	/* ̊֐ײ؂eʐsAOɌĂ΂
	 * ܂Bgp҂͑肵Mlhg֐Kp邽߂ɂ̈|gp
	 * 邱Ƃł܂(mzusC̉\)B */
#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
	qt_filter_callback = &set_timestamp1;
  #else
	qt_filter_callback = 0;
  #endif
#else
	qt_filter_callback = 0;
#endif

#ifdef _DEBUG_INTERFACE_
	QDebug_Init();				/* ޯދK񏉊 */
#endif
	__enable_interrupt();		/* S̊荞݋ */
#ifdef _DEBUG_INTERFACE_
    QDebug_ProcessCommands();	/* PC̖ߏ */
#endif
}

#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
void set_timestamp1 (void)
{
	TIMESTAMP1;
}
  #endif
#endif

/*============================================================================
O: touch_measure
------------------------------------------------------------------------------
ړI: ͐ڐG֘Ap̑SĂ̊֐Ăт܂B
: Ȃ
o: Ȃ
:
============================================================================*/
void touch_measure()
{
	/* ײ؂ɑ΂ďW߂̏׸ */
	static uint16_t status_flag = 0u;
	static uint16_t burst_flag = 0u;

	if( time_to_measure_touch )
	{
		time_to_measure_touch = 0u;		/* ׸މ:͐ڐG𑪒肷鎞ԂłB */

		do {
#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
			TIMESTAMP0;
  #endif
#endif
			status_flag = qt_measure_sensors( current_time_ms_touch );	/* 1ڐGm𑪒 */
#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
			TIMESTAMP2;
  #endif
#endif
			burst_flag = status_flag & QTLIB_BURST_AGAIN;
#ifdef _DEBUG_INTERFACE_
			QDebug_SendData(status_flag);	/* ޯ ްo */
			QDebug_ProcessCommands();		/* PC̖߂ */
#endif
#ifdef _DEBUG_INTERFACE_
  #ifdef _QDEBUG_TIME_STAMPS_
			TIMESTAMP3;
  #endif
#endif
			/* Ԃdvνĉpނ͂ōs܂B */
		}while (burst_flag) ;
	}
}

/*============================================================================
O: qt_set_parameters
------------------------------------------------------------------------------
ړI: ͌`Ԑݒް\̂Ŋ臒l𖞂܂BAgp҂͂
	  Ұ̒lύX邱Ƃł܂B
: Ȃ
o: Ȃ
: QTouch Studio琶ꂽށBύXȂłB
============================================================================*/
static void qt_set_parameters (void)
{
	/* ͎gp҂ɂĈႤlɕύXł傤B */
	qt_config_data.qt_di              = 2;
	qt_config_data.qt_neg_drift_rate  = 20;
	qt_config_data.qt_pos_drift_rate  = 5;
	qt_config_data.qt_max_on_duration = 0;
	qt_config_data.qt_drift_hold_time = 20;
	qt_config_data.qt_recal_threshold = 1;
	qt_config_data.qt_pos_recal_delay = 0;
}

/*============================================================================
O: config_sensors -
------------------------------------------------------------------------------
ړI: m`Ԑݒ
: Ȃ
o: Ȃ
: QTouch Studio琶ꂽށBύXȂłB
============================================================================*/
static void config_sensors (void)
{
	qt_enable_rotor( CHANNEL_0, CHANNEL_3, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u );
	qt_enable_slider( CHANNEL_4, CHANNEL_7, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u  );
	qt_enable_key( CHANNEL_8, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_9, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_10, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_11, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_12, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_13, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_14, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_15, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_rotor( CHANNEL_16, CHANNEL_19, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u );
	qt_enable_slider( CHANNEL_20, CHANNEL_23, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u  );
	qt_enable_key( CHANNEL_24, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_25, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_26, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_27, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_28, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_29, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_30, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_31, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_rotor( CHANNEL_32, CHANNEL_35, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u );
	qt_enable_slider( CHANNEL_36, CHANNEL_39, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u  );
	qt_enable_key( CHANNEL_40, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_41, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_42, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_43, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_44, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_45, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_46, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_47, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_rotor( CHANNEL_48, CHANNEL_51, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u );
	qt_enable_slider( CHANNEL_52, CHANNEL_55, NO_AKS_GROUP, 10u, HYST_6_25, RES_8_BIT, 0u  );
	qt_enable_key( CHANNEL_56, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_57, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_58, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_59, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_60, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_61, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_62, NO_AKS_GROUP, 10u, HYST_6_25 );
	qt_enable_key( CHANNEL_63, NO_AKS_GROUP, 10u, HYST_6_25 );
}
