/*******************************************************************************
*   $FILE:  eeprom_access.h
*   Atmel Corporation:  http://www.atmel.com \n
*   xEҰ:  touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

#ifndef EEPROM_ACCESS_H
#define EEPROM_ACCESS_H

/*----------------------------------------------------------------------------
qɂꂽݸٰ ̧
----------------------------------------------------------------------------*/
#include "touch_api.h"

#if defined ( __ICCAVR__ )
  #include <ioavr.h>
  #if !defined(__XMEGA_CORE__)				// 
	#define EEPROM_START_ADDRESS 0x0000u	/* gpEEPROMڽ */
  #else /* !defined(__ATxmega128A1_H) */
	#define EEPROM_START_ADDRESS 0x1000u	/* gpEEPROMڽ */
	#define _ATXMEGA_DEVICE_ 1u
  #endif /* !defined(__ATxmega128A1_H) */
#elif defined( __GNUC__ ) /* defined ( __ICCAVR__ ) */
  #include <avr/io.h>
  #if !defined(__AVR_XMEGA__)
	#define EEPROM_START_ADDRESS 0x0000u	/* gpEEPROMڽ */
  #else /* !defined(__AVR_ATxmega128A1__) */
	#define EEPROM_START_ADDRESS 0x1000u	/* gpEEPROMڽ */
	#define _ATXMEGA_DEVICE_ 1u
  #endif /* !defined(__AVR_ATxmega128A1__) */
#endif /* defined( __GNUC__ ) */

/*----------------------------------------------------------------------------
炩Ȓ萔
----------------------------------------------------------------------------*/
/* EEPROM̉Jnڽ */
#define EEPROM_LIB_CONFIG_START_ADDRESS  (EEPROM_START_ADDRESS + 2u)

/*==============================================================================
O: write_global_settings_to_eeprom
--------------------------------------------------------------------------------
ړI: SҰݒEEPROM֕ۑ
:
o:
:
==============================================================================*/
void write_global_settings_to_eeprom (void);

/*==============================================================================
O: write_sensor_settings_to_eeprom
--------------------------------------------------------------------------------
ړI: mҰݒEEPROM֕ۑ
:
o:
:
==============================================================================*/
void write_sensor_settings_to_eeprom (void);

#ifdef _QMATRIX_
/*==============================================================================
O: write_burst_lenghts_to_eeprom
--------------------------------------------------------------------------------
ړI: WݒEEPROM֕ۑ
:
o:
:
==============================================================================*/
void write_burst_lenghts_to_eeprom (void);
#endif

/*==============================================================================
O: read_info_from_eeprom
--------------------------------------------------------------------------------
ړI: EEPROM򕔓ǂݍ
:
o:
:
==============================================================================*/
uint16_t read_info_from_eeprom (void);

/*==============================================================================
O: write_info_to_eeprom
--------------------------------------------------------------------------------
ړI: ײ؂̏ۑEEPROMɏ
:
o:
:
==============================================================================*/
void write_info_to_eeprom (uint16_t lib_version);

/*==============================================================================
O: read_settings_from_eeprom
--------------------------------------------------------------------------------
ړI: EEPROMݒǂݍ
:
o:
: ް͏Ŏ`'eeprom_gv_block[]'Ɋi[܂B
==============================================================================*/
void read_settings_from_eeprom (void);

#endif /* EEPROM_ACCESS_H */
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-EOF-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
