/*******************************************************************************
*   touch.h
*   Atmel Corporation:  http://www.atmel.com \n
*   xEҰ:  touch@atmel.com
******************************************************************************/
/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/
/* ͎Iɐꂽ̧قłBe蓮ŕύXȂłB
   ɁA݌vɕύXsɂProject BuilderްނgpĂB
*/
/**
  * ̎Zp
  *
  * \Ȓl: _QMATRIX_, _QTOUCH_ .
  */
#define _QMATRIX_

/**
  * ޲
  *
  */
#define __ATmega324PA__

/**
  * eʏ[dٽ߂xBl01ۯ̏[dٽA12ۯ
  * ̕AȉlłB
  *
  * \Ȓl: 1,2,3,4,5,10,25,50
  */
#ifndef QT_DELAY_CYCLES
  #define QT_DELAY_CYCLES	1
#endif

/**
  * gp]q/q̐`
  * \Ȓl: 0			(_ROTOR_SLIDER_`Ȃꍇ)
  *			  1,2,4,8	(_ROTOR_SLIDER_`ꂽꍇ)
  * gpײ؂Ɉˑ
  */
#define QT_MAX_NUM_ROTORS_SLIDERS	8
#define _ROTOR_SLIDER_

/**
  * ِ(gpײ؂ƉpKvɈˑ)BpŕKvƂ
  * čŒ\ȐBِÎ葽̏QTouchײ؎gp̎pdf
  * ײؑI̎xlsQƂĂB
  *
  * \Ȓl: 4,8,12,16,32		(QTouch̏ꍇ)
  * \Ȓl: 4,8,16,32,56,64	(QMatrix̏ꍇ)
  */
#define QT_NUM_CHANNELS		64
/**
  * gpX`
  * \Ȓl: 4܂8
  * gpײ؂ɈˑBِÎ葽̏QTouchײ؎gp̎
  * pdfײؑI̎xlsQƂĂB
  *
  */
#define NUM_X_LINES			8
/**
  * Xz߰Đw
  * :xXɑ΂čő3߰Ă񋟂܂B
  *    (NUM_X_PORTSɑ΂\ȍől3)
  * \Ȓl: 1,2,3
  * ܂AXɑ΂Ďgp߰Đźޗp؂邱ƂɒӂĂB
  */
#define NUM_X_PORTS			1
/**
  * łǂ߰ĂXwBϸۂX쓮߰Ăɑ΂
  * xŏ߲ق̂߂Ɏgp܂B
  */
#define PORT_X_1			D

/**
  * gpY`
  * \Ȓl: 1,2,4,8
  * gpײ؂ɈˑBِÎ葽̏QTouchײ؎gp̎
  * pdfײؑI̎xlsQƂĂB
  */
#define NUM_Y_LINES			8

/**
  * YAYBɑ΂߰Ăw
  * YAYBɑ΂߰Ăw肷KɂĂQTouchײ؎gp҂̎pdf
  * Ӑ[ׂĂB
  */
#define PORT_YA				C
#define PORT_YB				A

/**
  * SHARED_YA_YBYAYB߰Ă̏ꍇ1AȂ0łׂłB
  */
#define SHARED_YAYB			0
/**
  * SMPp߰Ďw
  * ƑISMP߰ĂłSMPp݂wBpɑ΂Ăǂ̔ėpo݂g
  * p鑼̐ڐG݂ƏՓ˂܂B
  */
#define PORT_SMP			B
#define SMP_PIN				3

#define PORT_NUM_1			1

/**
  * Ԃ͐ڐG𑪒肷鎞Ԃ߂܂B
  *
  * \Ȓl:
  */
#define QT_MEASUREMENT_PERIOD_MS	50u

/**
  * ms̑v
  * TICKS_PER_MS = (CLK_FREQ/TIMER_PRESCALER)*(1/1000)
  */
#define TICKS_PER_MS				8u

/******************************************************************************
* ޯ ̪ݒ
******************************************************************************/

#define _DEBUG_INTERFACE_

/* ޯđSPI呕u */
#define QDEBUG_SPI_BB

#define SS_BB				4
#define SCK_BB				7
#define MOSI_BB				5
#define MISO_BB				6

#define SPI_BB_SS			B
#define SPI_BB_SCK			B
#define SPI_BB_MOSI			B
#define SPI_BB_MISO			B

#define PROJECT_ID			24
