/*
 * \file
 *
 * \brief
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_SPI)

/*============================ ݸٰ =======================================*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "SPI_Master.h"
#include "QDebugTransport.h"

/*============================  ==========================================*/

/*============================================================================
O: SPI_Master_Init
------------------------------------------------------------------------------
ړI: SPI̪
: Ȃ
o: Ȃ
: QDebug.cQDebug_InitĂ΂܂B
============================================================================*/
void SPI_Master_Init (void)
{
	// : SĂDDRlowlevelinit.cŐݒ肳܂B
	//	   ]uؾĂlowlevelinit.cŏ܂B

	// MOSI,SCK,SS͏óAMISOٱ
	SPI_DDR |= (1<<SS) | (1<<MOSI) | (1<<SCK) ;
	SPI_DDR &=~(1<<MISO);
	SPI_PORT &=~ ((1<<SS) | (1<<SCK) | (1<<MOSI)) ;
	SPI_PORT |= (1<<MISO);

	// SCK/fosc/2SPI呕u싖
	SPCR0 = (1<<MSTR0) | (1<<SPE0)|(0<<SPR10)|(0<<SPR00);
	SPSR0 |=(1<<SPI2X0);

	// SCK/fosc/4SPI呕u싖
//	SPCR = (1<<MSTR0) | (1<<SPE0)|(0<<SPR01)|(0<<SPR00);
//	SPSR &=~(1<<SPI2X0);

	// SCK/fosc/8SPI呕u싖
//	SPCR = (1<<MSTR0) | (1<<SPE0)|(0<<SPR01)|(1<<SPR00);
//	SPSR |=(1<<SPI2X0);

	// SCK/fosc/16SPI呕u싖
//	SPCR = (1<<MSTR0) | (1<<SPE0)|(1<<SPR00);
//	SPSR &=~(1<<SPI2X0);

	// SCK/fosc/32SPI呕u싖
//	SPCR = (1<<MSTR) | (1<<SPE)|(1<<SPR1)|(0<<SPR0);
//	SPSR |=(1<<SPI2X);
}

/*============================================================================
O: SPI_Send_Byte
------------------------------------------------------------------------------
ړI: SPI̪gp1޲đM
: ]u֑ް
o: ]uǂް
: SPI_Send_MessageĂ΂܂B
============================================================================*/
#pragma inline
uint8_t SPI_Send_Byte(uint8_t c)
{
	uint8_t temp;

	SPDR0 = c;							// SPIްMJn
	while (!(SPSR0 & (1<<SPIF0)));		// ޲đMҋ@
	temp=SPDR0;							// Mް擾(SPIF׸މ)
	DELAYUS(75);
    return temp;
}

/*============================================================================
O: SPI_Send_Message
------------------------------------------------------------------------------
ړI: SPI̪gp1ڰёM
: Ȃ
o: Ȃ
: QDebugTransport.cSend_MessageĂ΂܂B
============================================================================*/
void SPI_Send_Message (void)
{
	uint16_t i;
	uint8_t FrameInProgress;

	// үޑo
	for (i=0; i <= TX_index; i++)
	{
		FrameInProgress = RxHandler(SPI_Send_Byte(TX_Buffer[i]));
	}

	// ޲ĎMKv?
	while (FrameInProgress)
		FrameInProgress = RxHandler(SPI_Send_Byte(0));

}

#endif/* _DEBUG_INTERFACE_*/
